using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_JD_ProductCategory : EntityBase<T_JD_ProductCategory>, ICloneable
    {
        public Guid ProductCategoryGuid{ get;set; }
        public string CategoryCode{ get;set; }
        public int? Sort{ get;set; }   
        public string CategoryName{ get;set; }
        public string CategoryNameSpell{ get;set; }
        public int? Level{ get;set; }   
        public int? Leaf{ get;set; }   
        public int? Spuid{ get;set; }   
        public int? Status{ get;set; }   
        public string Sid{ get;set; }
        public string ParentNode{ get;set; }
        public bool? IsVirtual{ get;set; }   
        public bool? Complete{ get;set; }   
        public Guid? SMerchantGuid{ get;set; }   
        
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_JD_ProductCategory DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_JD_ProductCategory;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_JD_ProductCategory ShallowClone()
        {
            return Clone() as T_JD_ProductCategory;
        }
        #endregion
        
        #region 实体相互转换
        protected override T_JD_ProductCategory CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

